import { ElementRef, EventEmitter, QueryList, Renderer } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { Config } from '../../config/config';
import { NavParams } from '../../navigation/nav-params';
import { PickerOptions, PickerColumn, PickerColumnOption } from './picker-options';
import { UIEventManager } from '../../util/ui-event-manager';
import { ViewController } from '../../navigation/view-controller';
export declare class PickerColumnCmp {
    private elementRef;
    private _sanitizer;
    colEle: ElementRef;
    col: PickerColumn;
    y: number;
    colHeight: number;
    optHeight: number;
    velocity: number;
    pos: number[];
    startY: number;
    rafId: number;
    bounceFrom: number;
    minY: number;
    maxY: number;
    rotateFactor: number;
    lastIndex: number;
    receivingEvents: boolean;
    events: UIEventManager;
    ionChange: EventEmitter<any>;
    constructor(config: Config, elementRef: ElementRef, _sanitizer: DomSanitizer);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    pointerStart(ev: UIEvent): boolean;
    pointerMove(ev: UIEvent): void;
    pointerEnd(ev: UIEvent): void;
    decelerate(): void;
    optClick(ev: UIEvent, index: number): void;
    setSelected(selectedIndex: number, duration: number): void;
    update(y: number, duration: number, saveY: boolean, emitChange: boolean): void;
    refresh(): void;
}
export declare class PickerCmp {
    private _viewCtrl;
    private _elementRef;
    private _config;
    _cols: QueryList<PickerColumnCmp>;
    d: PickerOptions;
    enabled: boolean;
    lastClick: number;
    id: number;
    mode: string;
    constructor(_viewCtrl: ViewController, _elementRef: ElementRef, _config: Config, params: NavParams, renderer: Renderer);
    ionViewDidLoad(): void;
    refresh(): void;
    _colChange(selectedOption: PickerColumnOption): void;
    _keyUp(ev: KeyboardEvent): void;
    ionViewDidEnter(): void;
    btnClick(button: any, dismissDelay?: number): void;
    bdClick(): void;
    dismiss(role: any): Promise<any>;
    getSelected(): any;
}
