import { EventEmitter, NgZone } from '@angular/core';
import { Content } from '../content/content';
import { GestureController, GestureDelegate } from '../../gestures/gesture-controller';
import { PointerEvents, UIEventManager } from '../../util/ui-event-manager';
export declare class Refresher {
    private _content;
    private _zone;
    _appliedStyles: boolean;
    _didStart: boolean;
    _lastCheck: number;
    _isEnabled: boolean;
    _gesture: GestureDelegate;
    _events: UIEventManager;
    _pointerEvents: PointerEvents;
    _top: string;
    state: string;
    startY: number;
    currentY: number;
    deltaY: number;
    progress: number;
    pullMin: number;
    pullMax: number;
    closeDuration: number;
    snapbackDuration: number;
    enabled: boolean;
    ionRefresh: EventEmitter<Refresher>;
    ionPull: EventEmitter<Refresher>;
    ionStart: EventEmitter<Refresher>;
    constructor(_content: Content, _zone: NgZone, gestureCtrl: GestureController);
    _onStart(ev: TouchEvent): any;
    _onMove(ev: TouchEvent): number;
    _onMoveInZone(): number;
    _onEnd(): void;
    _beginRefresh(): void;
    complete(): void;
    cancel(): void;
    _close(state: string, delay: string): void;
    _setCss(y: number, duration: string, overflowVisible: boolean, delay: string): void;
    _setListeners(shouldListen: boolean): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
