import { AfterContentInit, ChangeDetectorRef, DoCheck, ElementRef, IterableDiffers, IterableDiffer, NgZone, OnDestroy, QueryList, Renderer, TrackByFn } from '@angular/core';
import { Config } from '../../config/config';
import { Content } from '../content/content';
import { Img } from '../img/img';
import { Platform } from '../../platform/platform';
import { ViewController } from '../../navigation/view-controller';
import { VirtualCell, VirtualData, VirtualNode } from './virtual-util';
import { VirtualFooter, VirtualHeader, VirtualItem } from './virtual-item';
export declare class VirtualScroll implements DoCheck, AfterContentInit, OnDestroy {
    private _iterableDiffers;
    private _elementRef;
    private _renderer;
    private _zone;
    private _cd;
    private _content;
    private _platform;
    private _ctrl;
    _trackBy: TrackByFn;
    _differ: IterableDiffer;
    _unreg: Function;
    _init: boolean;
    _rafId: number;
    _tmId: number;
    _hdrFn: Function;
    _ftrFn: Function;
    _records: any[];
    _cells: VirtualCell[];
    _nodes: VirtualNode[];
    _vHeight: number;
    _lastCheck: number;
    _data: VirtualData;
    _eventAssist: boolean;
    _queue: number;
    _itmTmp: VirtualItem;
    _hdrTmp: VirtualHeader;
    _ftrTmp: VirtualFooter;
    _imgs: QueryList<Img>;
    virtualScroll: any;
    bufferRatio: number;
    approxItemWidth: string;
    approxItemHeight: string;
    approxHeaderWidth: string;
    approxHeaderHeight: string;
    approxFooterWidth: string;
    approxFooterHeight: string;
    headerFn: Function;
    footerFn: Function;
    virtualTrackBy: TrackByFn;
    constructor(_iterableDiffers: IterableDiffers, _elementRef: ElementRef, _renderer: Renderer, _zone: NgZone, _cd: ChangeDetectorRef, _content: Content, _platform: Platform, _ctrl: ViewController, config: Config);
    ngDoCheck(): void;
    ngAfterContentInit(): void;
    update(checkChanges: boolean): void;
    renderVirtual(): void;
    postRenderVirtual(): void;
    scrollUpdate(): void;
    onScrollEnd(): void;
    setVirtualHeight(newVirtualHeight: number): void;
    addScrollListener(): void;
    ngOnDestroy(): void;
}
