(function (factory) {
    if (typeof module === 'object' && typeof module.exports === 'object') {
        var v = factory(require, exports); if (v !== undefined) module.exports = v;
    }
    else if (typeof define === 'function' && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    var Debouncer = (function () {
        function Debouncer(wait) {
            this.wait = wait;
            this.timer = null;
        }
        Debouncer.prototype.debounce = function (callback) {
            this.callback = callback;
            this.schedule();
        };
        Debouncer.prototype.schedule = function () {
            if (this.timer) {
                clearTimeout(this.timer);
                this.timer = null;
            }
            if (this.wait <= 0) {
                this.callback();
            }
            else {
                this.timer = setTimeout(this.callback, this.wait);
            }
        };
        return Debouncer;
    }());
    exports.Debouncer = Debouncer;
});
